﻿@using Jb.Framework.Common.Forms
@using Jb.Framework.Common.Forms.Validation
@using Jumbula.Common.Helper

@model  JbEmail

@{

    var textBoxHtmlAttr = new Dictionary<string, object>();
    var cssClasses = new List<string>();

    var width = "element_width-third";
    switch (Model.Width)
    {
        case ElementWidth.Half:
            {
                width = "element_width-half";
            }
            break;
        case ElementWidth.Full:
            {
                width = "element_width-full";
            }
            break;
    }

    cssClasses.Add(Model.Size.ToDescription());
    if (cssClasses.Any())
    {
        textBoxHtmlAttr.Add("class", string.Join(",", cssClasses) + " form-control");
    }
    textBoxHtmlAttr.Add("Type", "Email");
    textBoxHtmlAttr.Add("placeholder", Model.PlaceHolder);
    textBoxHtmlAttr.Add("data-clientid", Model.Name);


    if (Model.CurrentMode != AccessMode.Design)
    {
        if (Model.Validations.Any(x => x.Type != ElementValidationType.None))
        {
            textBoxHtmlAttr.Add("data-val", "true");
        }
        if (Model.Validations.Any(x => x.Type == ElementValidationType.Required))
        {
            textBoxHtmlAttr.Add("data-val-Required", Model.Validations.First(x => x.Type == ElementValidationType.Required).Message);
        }
        if (Model.CurrentMode == AccessMode.ReadOnly)
        {
            textBoxHtmlAttr.Add("ReadOnly", true);
        }
    }

}

<div class="form-group JbFormControll JbEmail @width" style="display: @(Model.VisibleMode != VisibilityMode.Both && Model.VisibleMode != (VisibilityMode)ViewBag.VisibleMode ? "none" : "block")">
    @for (var i = 0; i < Model.Validations.Count; i++)
    {
        //Custom model binder require full model name , i add Validations[i] at the end of string that mvc generate
        var hiddnModelBindername = "Validations[" + i + "].QVModelType";
        @Html.Hidden(hiddnModelBindername, Model.Validations[i].GetType())


        @Html.HiddenFor(x => x.Validations[i].IsChecked)
        @Html.HiddenFor(x => x.Validations[i].Type)
        @Html.HiddenFor(x => x.Validations[i].Message)
    }
    @Html.GenerateHiddenFields(Model)
    @Html.LabelFor(m => m.Value, Model.Title, new { @class = (Model.Validations.Any(t => t.Type == ElementValidationType.Required) || Model.IsRequired) ? "req" : "" })
    @if (!string.IsNullOrEmpty(Model.HelpText))
    {
        <a href="#" class="help" role="button" data-toggle="popover" data-trigger="focus" data-content="@Model.HelpText"></a>
    }
    @Html.TextBoxFor(model => model.Value, htmlAttributes: textBoxHtmlAttr)
    @Html.ValidationMessageFor(model => model.Value)
</div>



